"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from __future__ import annotations
import dataclasses
import requests as requests_http
from ...models.errors import error as errors_error
from ...models.shared import apiendpoint as shared_apiendpoint
from ...models.shared import apiendpoint_input as shared_apiendpoint_input
from typing import Optional


@dataclasses.dataclass
class UpsertAPIEndpointRequest:
    api_endpoint: shared_apiendpoint_input.APIEndpointInput = dataclasses.field(metadata={'request': { 'media_type': 'application/json' }})
    r"""A JSON representation of the ApiEndpoint to upsert."""
    api_endpoint_id: str = dataclasses.field(metadata={'path_param': { 'field_name': 'apiEndpointID', 'style': 'simple', 'explode': False }})
    r"""The ID of the ApiEndpoint to upsert."""
    api_id: str = dataclasses.field(metadata={'path_param': { 'field_name': 'apiID', 'style': 'simple', 'explode': False }})
    r"""The ID of the Api the ApiEndpoint belongs to."""
    version_id: str = dataclasses.field(metadata={'path_param': { 'field_name': 'versionID', 'style': 'simple', 'explode': False }})
    r"""The version ID of the Api the ApiEndpoint belongs to."""
    



@dataclasses.dataclass
class UpsertAPIEndpointResponse:
    content_type: str = dataclasses.field()
    r"""HTTP response content type for this operation"""
    status_code: int = dataclasses.field()
    r"""HTTP response status code for this operation"""
    raw_response: requests_http.Response = dataclasses.field()
    r"""Raw HTTP response; suitable for custom response parsing"""
    api_endpoint: Optional[shared_apiendpoint.APIEndpoint] = dataclasses.field(default=None)
    r"""OK"""
    error: Optional[errors_error.Error] = dataclasses.field(default=None)
    r"""Default error response"""
    

